#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using dl = double long;
ll INF = 1e18;

void bfs(vector<vector<ll>> &g, queue<pair<ll, ll>> &q, vector<ll> &dist) {
    while (!q.empty()) {
        ll v = q.front().first;
        ll h = q.front().second;
        q.pop();
        for (auto to: g[v]) {
            if (dist[to] > dist[v] + 1 && h > 0) {
                dist[to] = dist[v] + 1;
                q.push({to, h - 1});
            }
        }

    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll n, m, k;
    cin >> n >> m >> k;
    vector<vector<ll>> g(n);
    for (ll i = 0; i < m; i++) {
        ll x, y;
        cin >> x >> y;
        x--, y--;
        g[x].push_back(y);
        g[y].push_back(x);
    }
    vector<ll> dist(n, INF);
    queue<pair<ll, ll>> q;
    for (ll i = 0; i < k; i++) {
        ll x, h;
        cin >> x >> h;
        x--;
        q.push({x, h});
        dist[x] = 0;
    }
    bfs(g, q, dist);
    vector<ll> ans;
    for (ll i = 0; i < n; i++) {
        if (dist[i] != INF)
            ans.push_back(i + 1);
    }
    cout << ans.size() << '\n';
    for (auto i: ans)
        cout << i << " ";
}
